create or replace 
PROCEDURE EXPORTA_AS(P_CDFILIAL  IN VARCHAR2,
                     P_DTINICIAL IN DATE,
                     P_DTFINAL   IN DATE,
                     P_TCDFILIAL IN CHAR)
IS
   V_CDCHAVE      VARCHAR2(20);
   V_BUYER        VARCHAR2(30);
   V_VERFILIAL    VARCHAR2(60);
   V_FILIAL       VARCHAR2(4);
   V_ORG_COMPRA   VARCHAR2(4);
   V_GRUPO_COMPRA VARCHAR2(3);
   V_TIPO_DOCUM   VARCHAR2(4);
   V_SOCIEDAD     VARCHAR2(4);
   V_MONEDA       VARCHAR2(3);
   V_VALIDA       VARCHAR2(20);
   BOVALIDA       BOOLEAN;
   V_SEQUENCIAL   INTEGER;
   V_AFEXPORTADA  INTEGER;
   V_CDFILLANCATU VARCHAR2(4);
   V_CDFILDESTATU VARCHAR2(4);
   V_NRAUTOFORATU VARCHAR2(10);
   V_CDSITESAPATU VARCHAR2(4);
BEGIN
   V_VERFILIAL    := LENGTH(REGEXP_REPLACE(TRIM(P_CDFILIAL), '\d'));
   V_ORG_COMPRA   := 'CL01';
   V_GRUPO_COMPRA := '';
   V_TIPO_DOCUM   := 'ZCFP';
   V_SOCIEDAD     := 'CL10';
   V_MONEDA       := 'CLP';
   V_VALIDA       := '';
   BOVALIDA       := FALSE;
   
   IF ((V_VERFILIAL > 2) OR (P_TCDFILIAL = 'T')) THEN
      FOR C_AUTOFORNE IN
          (SELECT A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN, 
                  O.NMOPERADOR, PR.CDPRODINTE, I.QTPROGENTAF, I.DTPROGENTAF, 
                  ROW_NUMBER() OVER(PARTITION BY A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN ORDER BY I.CDPRODUTO) POSICION,
                  F.NRINSJURFORN, PR.SGUNIDADE, SUBSTR(P.CDEXFILIAL, 1, 4) CDEXFILIAL, M.CDPRODSAP, ROUND(I.VRPREUNIAF, 2) VRPREUNIAF,
                  PR.NMPRODUTO, F.CDEXFORNECED CDPROVEESAP
             FROM AUTOFORNE A, ITEMAUTF I, PRODUTO PR, OPERADOR O, FORNECEDOR F, PARAMFILIAL P, 
                  FILIAL FI, MARCPROD M
            WHERE A.CDFILDEST  = I.CDFILDEST
              AND A.CDFILLANC  = I.CDFILLANC
              AND A.NRAUTOFORN = I.NRAUTOFORN
              AND A.CDOPERADOR = O.CDOPERADOR
              AND I.CDPRODUTO  = PR.CDPRODUTO
              AND PR.CDPRODUTO = M.CDPRODUTO(+)
              AND A.CDFORNECED = F.CDFORNECED
              AND FI.CDFILIAL  = A.CDFILDEST
              AND P.CDFILIAL   = FI.CDFILIAL
              AND ((INSTR(P_CDFILIAL, '_'||A.CDFILDEST||'_') > 0) OR (P_TCDFILIAL = 'T'))
              AND A.DTAUTOFORN BETWEEN P_DTINICIAL AND P_DTFINAL
              AND A.USR_DTEXPORTA IS NULL
            ORDER BY A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN)
      LOOP
         V_CDCHAVE := C_AUTOFORNE.CDFILLANC||C_AUTOFORNE.CDFILDEST||C_AUTOFORNE.NRAUTOFORN;
         V_BUYER   := C_AUTOFORNE.CDFILDEST||SUBSTR(C_AUTOFORNE.NMOPERADOR, 1, 25);
         
         IF V_VALIDA <> V_CDCHAVE THEN
            IF BOVALIDA THEN
               COMMIT;
               UPDATE USR_SAP_AUTOFORNE
                  SET STATUS_TECFOOD = 2
                WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
                  AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
                  AND ORDEN         = C_AUTOFORNE.NRAUTOFORN;
                  
                  UPDATE AUTOFORNE
                     SET USR_DTEXPORTA = NULL
                   WHERE CDFILLANC  = C_AUTOFORNE.CDFILLANC
                     AND CDFILDEST  = C_AUTOFORNE.CDFILDEST
                     AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN;
               
               BOVALIDA := FALSE;
            ELSE
               IF (TRIM(V_VALIDA) IS NOT NULL) THEN
                  UPDATE AUTOFORNE
                     SET USR_DTEXPORTA = SYSDATE
                   WHERE CDFILLANC  = C_AUTOFORNE.CDFILLANC
                     AND CDFILDEST  = C_AUTOFORNE.CDFILDEST
                     AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN;
               END IF;
            END IF;
            
            SELECT COUNT(1)
              INTO V_AFEXPORTADA
              FROM USR_SAP_AUTOFORNE
             WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
               AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
               AND ORDEN         = C_AUTOFORNE.NRAUTOFORN;
            
            V_VALIDA := V_CDCHAVE;
         END IF;
         
         IF V_AFEXPORTADA > 0 THEN
            FOR C_AFEXISTE IN (SELECT ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                      MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                      STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                      TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                      CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP
                                 FROM USR_SAP_AUTOFORNE
                                WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
                                  AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
                                  AND ORDEN         = C_AUTOFORNE.NRAUTOFORN)
            LOOP
               SELECT USR_SAP_IDINTERFACE.NEXTVAL
                 INTO V_SEQUENCIAL
                 FROM DUAL;
               
               INSERT INTO USR_SAP_AUTOFORNE(ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                             MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                             IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                             TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                             CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP)
               VALUES(C_AFEXISTE.ORDEN, C_AFEXISTE.ORG_COMPRA, C_AFEXISTE.GRUPO_COMPRA, C_AFEXISTE.BUYER,
                      C_AFEXISTE.MATERIAL, C_AFEXISTE.CANTIDAD, C_AFEXISTE.FEC_ENTREGA, C_AFEXISTE.IDGERAORDCOMP,
                      V_SEQUENCIAL, 'E', SYSDATE, NULL, 1, 1, 2,
                      C_AFEXISTE.TIPO_DOCUM, C_AFEXISTE.POSICION, C_AFEXISTE.NIF_PROVEE, C_AFEXISTE.SOCIEDAD, C_AFEXISTE.UOM_ORDEN, C_AFEXISTE.MONEDA,
                      C_AFEXISTE.CDSITETECFOOD, C_AFEXISTE.CDSITESAP, C_AFEXISTE.PRECIO_UNITARIO, C_AFEXISTE.CDPROVEESAP);
            END LOOP;
            
            V_AFEXPORTADA := 0;
         END IF;
         
         SELECT USR_SAP_IDINTERFACE.NEXTVAL
           INTO V_SEQUENCIAL
           FROM DUAL;

         IF (C_AUTOFORNE.CDPRODSAP IS NOT NULL) THEN
            IF (C_AUTOFORNE.CDEXFILIAL IS NOT NULL) THEN
               IF (C_AUTOFORNE.CDPROVEESAP IS NOT NULL) THEN
                  INSERT INTO USR_SAP_AUTOFORNE(ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                                MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                                TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                                CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP)
                  VALUES(C_AUTOFORNE.NRAUTOFORN, V_ORG_COMPRA, V_GRUPO_COMPRA, V_BUYER,
                         C_AUTOFORNE.CDPRODSAP, C_AUTOFORNE.QTPROGENTAF, C_AUTOFORNE.DTPROGENTAF, 'N',
                         V_SEQUENCIAL, 'I', SYSDATE, NULL, 1, 1, 2,
                         V_TIPO_DOCUM, C_AUTOFORNE.POSICION, C_AUTOFORNE.NRINSJURFORN, V_SOCIEDAD, C_AUTOFORNE.SGUNIDADE, V_MONEDA,
                         C_AUTOFORNE.CDFILLANC, C_AUTOFORNE.CDEXFILIAL, C_AUTOFORNE.VRPREUNIAF, C_AUTOFORNE.CDPROVEESAP);
                  
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 0, 'Exportacin realizada con xito');

                  V_CDFILLANCATU := C_AUTOFORNE.CDFILLANC;
                  V_CDFILDESTATU := C_AUTOFORNE.CDFILDEST;
                  V_NRAUTOFORATU := C_AUTOFORNE.NRAUTOFORN;
                  V_CDSITESAPATU := C_AUTOFORNE.CDEXFILIAL;
               ELSE
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Proveedor '||C_AUTOFORNE.CDPROVEESAP||' no posee c'||CHR(243)||'digo SAP');
               END IF;
            ELSE
               BOVALIDA := TRUE;
               
               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Site '||C_AUTOFORNE.CDFILDEST||' no posee c'||CHR(243)||'digo SAP');
            END IF;
         ELSE
            BOVALIDA := TRUE;
            
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Producto '||C_AUTOFORNE.NMPRODUTO||' no posee c'||CHR(243)||'digo SAP');
         END IF;
      END LOOP;
   ELSE
      V_FILIAL := REGEXP_REPLACE(P_CDFILIAL, '\D');
      
      FOR C_AUTOFORNE IN
          (SELECT A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN, 
                  O.NMOPERADOR, PR.CDPRODINTE, I.QTPROGENTAF, I.DTPROGENTAF, 
                  ROW_NUMBER() OVER(PARTITION BY A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN ORDER BY I.CDPRODUTO) POSICION,
                  F.NRINSJURFORN, PR.SGUNIDADE, SUBSTR(P.CDEXFILIAL, 1, 4) CDEXFILIAL, M.CDPRODSAP, ROUND(I.VRPREUNIAF, 2) VRPREUNIAF, 
                  PR.NMPRODUTO, F.CDEXFORNECED CDPROVEESAP
             FROM AUTOFORNE A, ITEMAUTF I, PRODUTO PR, OPERADOR O, FORNECEDOR F, PARAMFILIAL P, 
                  FILIAL FI, MARCPROD M
            WHERE A.CDFILDEST  = I.CDFILDEST
              AND A.CDFILLANC  = I.CDFILLANC
              AND A.NRAUTOFORN = I.NRAUTOFORN
              AND A.CDOPERADOR = O.CDOPERADOR
              AND I.CDPRODUTO  = PR.CDPRODUTO
              AND PR.CDPRODUTO = M.CDPRODUTO(+)
              AND A.CDFORNECED = F.CDFORNECED
              AND FI.CDFILIAL  = A.CDFILDEST
              AND P.CDFILIAL   = FI.CDFILIAL
              AND A.CDFILDEST  = V_FILIAL
              AND A.DTAUTOFORN BETWEEN P_DTINICIAL AND P_DTFINAL
              AND A.USR_DTEXPORTA IS NULL
            ORDER BY A.CDFILLANC, A.CDFILDEST, A.NRAUTOFORN)
      LOOP
         V_CDCHAVE := C_AUTOFORNE.CDFILLANC||C_AUTOFORNE.CDFILDEST||C_AUTOFORNE.NRAUTOFORN;
         V_BUYER   := C_AUTOFORNE.CDFILDEST||SUBSTR(C_AUTOFORNE.NMOPERADOR, 1, 25);
         
         IF V_VALIDA <> V_CDCHAVE THEN
            IF BOVALIDA THEN
               COMMIT;
               UPDATE USR_SAP_AUTOFORNE
                  SET STATUS_TECFOOD = 2
                WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
                  AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
                  AND ORDEN         = C_AUTOFORNE.NRAUTOFORN;
               
               UPDATE AUTOFORNE
                  SET USR_DTEXPORTA = NULL
                WHERE CDFILLANC  = C_AUTOFORNE.CDFILLANC
                  AND CDFILDEST  = C_AUTOFORNE.CDFILDEST
                  AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN;
               
               BOVALIDA := FALSE;
            ELSE
               IF (TRIM(V_VALIDA) IS NOT NULL) THEN
                  UPDATE AUTOFORNE
                     SET USR_DTEXPORTA = SYSDATE
                   WHERE CDFILLANC  = C_AUTOFORNE.CDFILLANC
                     AND CDFILDEST  = C_AUTOFORNE.CDFILDEST
                     AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN;
               END IF;
            END IF;
            
            SELECT COUNT(1)
              INTO V_AFEXPORTADA
              FROM USR_SAP_AUTOFORNE
             WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
               AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
               AND ORDEN         = C_AUTOFORNE.NRAUTOFORN;
            
            V_VALIDA := V_CDCHAVE;
         END IF;
         
         IF V_AFEXPORTADA > 0 THEN
            FOR C_AFEXISTE IN (SELECT ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                      MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                      STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                      TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                      CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP
                                 FROM USR_SAP_AUTOFORNE
                                WHERE CDSITETECFOOD = C_AUTOFORNE.CDFILLANC
                                  AND CDSITESAP     = C_AUTOFORNE.CDEXFILIAL
                                  AND ORDEN         = C_AUTOFORNE.NRAUTOFORN)
            LOOP
               SELECT USR_SAP_IDINTERFACE.NEXTVAL
                 INTO V_SEQUENCIAL
                 FROM DUAL;
               
               INSERT INTO USR_SAP_AUTOFORNE(ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                             MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                             IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                             TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                             CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP)
               VALUES(C_AFEXISTE.ORDEN, C_AFEXISTE.ORG_COMPRA, C_AFEXISTE.GRUPO_COMPRA, C_AFEXISTE.BUYER,
                      C_AFEXISTE.MATERIAL, C_AFEXISTE.CANTIDAD, C_AFEXISTE.FEC_ENTREGA, C_AFEXISTE.IDGERAORDCOMP,
                      V_SEQUENCIAL, 'E', SYSDATE, NULL, 1, 1, 2,
                      C_AFEXISTE.TIPO_DOCUM, C_AFEXISTE.POSICION, C_AFEXISTE.NIF_PROVEE, C_AFEXISTE.SOCIEDAD, C_AFEXISTE.UOM_ORDEN, C_AFEXISTE.MONEDA,
                      C_AFEXISTE.CDSITETECFOOD, C_AFEXISTE.CDSITESAP, C_AFEXISTE.PRECIO_UNITARIO, C_AFEXISTE.CDPROVEESAP);
            END LOOP;
            
            V_AFEXPORTADA := 0;
         END IF;
         
         SELECT USR_SAP_IDINTERFACE.NEXTVAL
           INTO V_SEQUENCIAL
           FROM DUAL;
           
         IF (C_AUTOFORNE.CDPRODSAP IS NOT NULL) THEN
            IF (C_AUTOFORNE.CDEXFILIAL IS NOT NULL) THEN
               IF (C_AUTOFORNE.CDPROVEESAP IS NOT NULL) THEN
                  INSERT INTO USR_SAP_AUTOFORNE(ORDEN, ORG_COMPRA, GRUPO_COMPRA, BUYER,
                                                MATERIAL, CANTIDAD, FEC_ENTREGA,  IDGERAORDCOMP,
                                                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS_TECFOOD, APPORIGEM, APPDESTINO,
                                                TIPO_DOCUM, POSICION, NIF_PROVEE, SOCIEDAD, UOM_ORDEN, MONEDA,
                                                CDSITETECFOOD, CDSITESAP, PRECIO_UNITARIO, CDPROVEESAP)
                  VALUES (C_AUTOFORNE.NRAUTOFORN, V_ORG_COMPRA, V_GRUPO_COMPRA, V_BUYER,
                          C_AUTOFORNE.CDPRODSAP, C_AUTOFORNE.QTPROGENTAF, C_AUTOFORNE.DTPROGENTAF, 'N',
                          V_SEQUENCIAL, 'I', SYSDATE, NULL, 1, 1, 2,
                          V_TIPO_DOCUM, C_AUTOFORNE.POSICION, C_AUTOFORNE.NRINSJURFORN, V_SOCIEDAD, C_AUTOFORNE.SGUNIDADE, V_MONEDA,
                          C_AUTOFORNE.CDFILLANC, C_AUTOFORNE.CDEXFILIAL, C_AUTOFORNE.VRPREUNIAF, C_AUTOFORNE.CDPROVEESAP);
                  
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 0, 'Exportacin realizada con xito');

                  V_CDFILLANCATU := C_AUTOFORNE.CDFILLANC;
                  V_CDFILDESTATU := C_AUTOFORNE.CDFILDEST;
                  V_NRAUTOFORATU := C_AUTOFORNE.NRAUTOFORN;
                  V_CDSITESAPATU := C_AUTOFORNE.CDEXFILIAL;
               ELSE
                  BOVALIDA := TRUE;
                  
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Proveedor '||C_AUTOFORNE.CDPROVEESAP||' no posee c'||CHR(243)||'digo SAP');
               END IF;
            ELSE
               BOVALIDA := TRUE;
               
               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Site '||C_AUTOFORNE.CDFILDEST||' no posee c'||CHR(243)||'digo SAP');
            END IF;
         ELSE
            BOVALIDA := TRUE;
            
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(V_SEQUENCIAL, 'I', 7, SYSDATE, 1, 'Producto '||C_AUTOFORNE.NMPRODUTO||' no posee c'||CHR(243)||'digo SAP');
         END IF;
      END LOOP;
   END IF;

   UPDATE USR_SAP_AUTOFORNE
      SET STATUS_TECFOOD = 2
    WHERE CDSITETECFOOD = V_CDFILLANCATU
      AND CDSITESAP     = V_CDSITESAPATU
      AND ORDEN         = V_NRAUTOFORATU;
      
   UPDATE AUTOFORNE
      SET USR_DTEXPORTA = NULL
    WHERE CDFILLANC  = V_CDFILLANCATU
      AND CDFILDEST  = V_CDFILDESTATU
      AND NRAUTOFORN = V_NRAUTOFORATU;
   
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_AS','5.45.XXX'); END;
/